import 'package:flutter/material.dart';

///[NavigationDestination] class is encapsulated [BackdropPage] and addition args
class NavigationDestination{
  NavigationDestination({@required this.icon, @required this.title, this.subTitle, this.actions = const <Widget>[], @required this.child}) : assert(icon != null && title != null && child != null);
  final Icon icon;
  final Widget title;
  final Widget subTitle;
  final List<Widget> actions;
  final WidgetBuilder child;
}

class BackdropPage extends StatelessWidget{
  BackdropPage({Key key, this.subTitle, @required this.child, @required this.fling}) : assert(child != null && fling != null), super(key: key);
  final Widget subTitle;
  final WidgetBuilder child;
  final void Function() fling;
  @override
  Widget build(BuildContext context) {
    return  Container(
      padding: subTitle != null ? EdgeInsets.symmetric(horizontal: 16) : EdgeInsets.zero,
      child: Column(
        children: <Widget>[
          subTitle != null ? Container(
            color: Theme.of(context).scaffoldBackgroundColor,
            padding: EdgeInsets.symmetric(vertical: 8, horizontal: 0.0),
            height: 46,
            child: Row(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              mainAxisSize: MainAxisSize.max,
              children: <Widget>[
                subTitle,
              ],
            ),
          ) : Container(),
          GestureDetector(
            behavior: HitTestBehavior.translucent,
            onTap: fling,
            child: SizedBox(
              height: subTitle != null ? MediaQuery.of(context).size.height - (46 + 33 + kToolbarHeight) : MediaQuery.of(context).size.height - (kToolbarHeight + 33),
              width: subTitle != null ? MediaQuery.of(context).size.width - 32 : MediaQuery.of(context).size.width,
              child: child(context),
            ),
          )
        ],
      ),
    );
  }
}